﻿using Blazor.Models;
using Blazor.Services;
using Microsoft.AspNetCore.Components;

namespace Blazor.Pages
{
    public partial class EditChapter
    {
        [Parameter]
        public int Id { get; set; }

        private ChapterModel chapterModel = new();

        [Inject]
        public IDataService DataService { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }

        [Inject]
        public IWebHostEnvironment WebHostEnvironment { get; set; }

        protected override async Task OnInitializedAsync()
        {
            var chapter = await DataService.GetById(Id);

            // Set the model with the chapter
            chapterModel = new ChapterModel
            {
                Id = chapter.Id,
                Name = chapter.Name
            };
        }

        private async void HandleValidSubmit()
        {
            await DataService.Update(Id, chapterModel);

            NavigationManager.NavigateTo("chapters");
        }
    }
}
